// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from robot_calibration_msgs:msg/Observation.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "robot_calibration_msgs/msg/observation.h"


#ifndef ROBOT_CALIBRATION_MSGS__MSG__DETAIL__OBSERVATION__STRUCT_H_
#define ROBOT_CALIBRATION_MSGS__MSG__DETAIL__OBSERVATION__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'sensor_name'
#include "rosidl_runtime_c/string.h"
// Member 'features'
#include "geometry_msgs/msg/detail/point_stamped__struct.h"
// Member 'ext_camera_info'
#include "robot_calibration_msgs/msg/detail/extended_camera_info__struct.h"
// Member 'cloud'
#include "sensor_msgs/msg/detail/point_cloud2__struct.h"
// Member 'image'
#include "sensor_msgs/msg/detail/image__struct.h"

/// Struct defined in msg/Observation in the package robot_calibration_msgs.
/**
  * Name of the "sensor" that generate this data.
 */
typedef struct robot_calibration_msgs__msg__Observation
{
  rosidl_runtime_c__String sensor_name;
  /// Features "detected" by the sensor.
  geometry_msgs__msg__PointStamped__Sequence features;
  /// Sensor information
  robot_calibration_msgs__msg__ExtendedCameraInfo ext_camera_info;
  /// Debugging data (optional)
  sensor_msgs__msg__PointCloud2 cloud;
  sensor_msgs__msg__Image image;
} robot_calibration_msgs__msg__Observation;

// Struct for a sequence of robot_calibration_msgs__msg__Observation.
typedef struct robot_calibration_msgs__msg__Observation__Sequence
{
  robot_calibration_msgs__msg__Observation * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} robot_calibration_msgs__msg__Observation__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ROBOT_CALIBRATION_MSGS__MSG__DETAIL__OBSERVATION__STRUCT_H_
